package com.fp.persistence.pgeneral.menu;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.Query;

import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;

import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENEMENUPROFILE*/
@Entity(name="TgeneMenuProfile")
@Table(name="TGENEMENUPROFILE")
public class TgeneMenuProfile extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneMenuProfile
*/
@Id
@Column(name="PROFILECODE" ,nullable=false, updatable=false)
private String pk;
@Column(name="MENUCODE", nullable=true)

/**
* Código del ítem de menú
*/
private Integer menucode;

/**Contructor por defecto*/
public TgeneMenuProfile(){
}
/**Contructor de TgeneMenuProfile
@param pPk Clave Primaria del entity
*/
public TgeneMenuProfile(String pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneMenuProfile
*/
public static TgeneMenuProfile find(EntityManager pEntityManager,Object pKey) throws Exception{
    TgeneMenuProfile obj = pEntityManager.find(TgeneMenuProfile.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneMenuProfile
@return El objeto que referencia a la Clave primaria de TgeneMenuProfile
*/
public String getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneMenuProfile
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneMenuProfile
*/
public void setPk(String pPk){
  pk=pPk;
}
/**Obtiene el valor de menucode
@return valor de menucode*/
public Integer getMenucode(){
  return menucode;
}
/**Fija el valor de menucode
@param pMenucode nuevo Valor de menucode*/
public void setMenucode(Integer pMenucode){
  menucode=pMenucode;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneMenuProfile))return false;
    TgeneMenuProfile that = (TgeneMenuProfile) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneMenuProfile
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneMenuProfile
*/
public Object createInstance(){
 TgeneMenuProfile instance=new TgeneMenuProfile();	
 return instance;
}
/**Clona la entidad TgeneMenuProfile
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneMenuProfile p=(TgeneMenuProfile)this.clone();
  return p;
}

	//METODOS MANUALES
	/** Sentencia que devuelve un registro de TgeneMenuProfile. */
	private static final String JPQL_MENU_PROFILE = "from TgeneMenuProfile tmp  " + " where tmp.pk = :profilecode";
	/**
     * Metodo que entrega datos de TgeneMenuProfile.
     * 
     * @param pProfile Codigo de perfil del usuario.
     * @return TgeneMenuProfile
     * @throws Exception
     */
    public static TgeneMenuProfile findByCodePerfilUsuario(EntityManager pEntityManager, String pProfile) throws Exception {
        Query qry = pEntityManager.createQuery(TgeneMenuProfile.JPQL_MENU_PROFILE);
        qry.setParameter("profilecode", pProfile);
        try {
        	return (TgeneMenuProfile) qry.getSingleResult();
		} catch (NoResultException e) {
			return null;
		}
    }
	
}
